#include "listaT.h"

listT emptyListT()
{
	return NULL;
}

listT consT(Total newValue, listT l)
{
	itemT *temp = (itemT *)malloc(sizeof(itemT));
	temp->value = newValue;
	temp->next = l;
	return temp;
}

Total headT(listT l)
{
	return l->value;
}

listT tailT(listT l)
{
	return l->next;
}

int isEmptyT(listT l)
{
	return l == NULL;
}


void destroyItemT(listT l)
{
	destroyP_wo_content(l->value.p);
	free(l);
}

void destroyListT(listT l)
{
	listT temp;
	while (!isEmptyT(l))
	{
		temp = l->next;
		destroyItemT(l);
		l = temp;
	}
}


listT appendT(Total newValue, listT l)
{
	listT result = l;

	if (isEmptyT(result))
	{
		result = consT(newValue, l);
	}
	else
	{
		while (!isEmptyT(l->next))
			l = tailT(l);
		l->next = consT(newValue, emptyListT());
	}
	return result;
}


void addParte(int idMacchina, Parte * newParte, listT l)
{
	while ((headT(l).m)->id != idMacchina)
		l = tailT(l);
	(l->value).p = appendP(newParte, (l->value).p);
}



int countParte(int idMacchina, listT l)
{
	while ((headT(l).m)->id != idMacchina)
		l = tailT(l);
	return lengthP((l->value).p);
}

int costo(int idMacchina, listT l)
{
	while ((headT(l).m)->id != idMacchina)
		l = tailT(l);
	return costP((l->value).p);
}


