#include "listaP.h"

listP emptyListP()
{
	return NULL;
}

listP consP(Parte * newValue, listP l)
{
	itemP *temp = (itemP *)malloc(sizeof(itemP));
	temp->value = newValue;
	temp->next = l;
	return temp;
}

Parte * headP(listP l)
{
	return l->value;
}

listP tailP(listP l)
{
	return l->next;
}

int isEmptyP(listP l)
{
	return l == NULL;
}


void destroyItemP_wo_content(listP l)
{
	free(l);
}

void destroyItemP_w_content(listP l)
{
	destroyParte(l->value);
	destroyItemP_wo_content(l);
}


listP appendP(Parte * newValue, listP l)
{
	listP result = l;

	if (isEmptyP(result))
	{
		result = consP(newValue, l);
	}
	else
	{
		while (!isEmptyP(l->next))
			l = tailP(l);
		l->next = consP(newValue, emptyListP());
	}
	return result;
}

void destroyP_w_content(listP l)
{
	listP temp;

	while (! isEmptyP(l))
	{
		temp = l;
		l = tailP(l);
		destroyItemP_w_content(temp);
	}
}

void destroyP_wo_content(listP l)
{
	listP temp;

	while (! isEmptyP(l))
	{
		temp = l;
		l = tailP(l);
		destroyItemP_wo_content(temp);
	}
}


int lengthP(listP l)
{
	int result = 0;
	while (!isEmptyP(l))
	{
		result++;
		l = tailP(l);
	}
	return result;
}

int costP(listP l)
{
	int result = 0;
	while (!isEmptyP(l))
	{
		result = result + headP(l)->costo;
		l = tailP(l);
	}
	return result;
}