#ifndef LISTAT
#define LISTAT

#include "macchine.h"
#include "listaP.h"
#include "listaM.h"

typedef struct total_struct
{
	Macchina * m;
	listP p;
}
Total;



typedef struct itemT_struct
{
	Total value;
	struct itemT_struct *next;
} itemT;

typedef itemT *listT;


listT emptyListT();
int isEmptyT(listT l);
listT consT(Total newValue, listT l);
Total headT(listT l);
listT tailT(listT l);

void destroyItemT(listT l);
void destroyListT(listT l);
listT appendT(Total newValue, listT l);
void addParte(int idMacchina, Parte * newParte, listT l);
int countParte(int idMacchina, listT l);
int costo(int idMacchina, listT l);


#endif