/**********************************************************************
*       Author   : Federico Chesani
*       Created  : 6/12/2007 - 0:4
*       Modified : 6/12/2007 - 0:4
*
*       Description :
*         No description
***********************************************************************/


#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "macchine.h"
#include "listaM.h"
#include "listaP.h"
#include "listaT.h"


listT merge(listM lm, listP lp)
{
	listT result = emptyListT();
	listP resultP;
	listP temp;
	int idMacchina;
	Total tempTotal;

	while (!isEmptyM(lm))
	{
		idMacchina = headM(lm)->id;
		temp = lp;
		resultP = emptyListP();

		while (! isEmptyP(temp))
		{
			if (headP(temp)->idMacchina == idMacchina)
			{
				resultP = consP(headP(temp), resultP);
			}
			temp = tailP(temp);
		}
		tempTotal.m = headM(lm);
		tempTotal.p = resultP;
		result = consT(tempTotal, result);
		lm = tailM(lm);
	}
	return result;
}



int main(void)
{

	char tipoRiga = 0;
	FILE * fp;

	Macchina * m;
	Parte * p;
	listM lm = emptyListM();
	listP lp = emptyListP();
	listT lt;
	listP temp;

	if ((fp=fopen("prova.txt", "r")) == NULL)
	{
		printf("Error opening file...");
		system("PAUSE");
		exit(-1);
	}
	while (!feof(fp))
	{
		tipoRiga = fgetc(fp);
		switch (tipoRiga) 
		{
			case 'M':
				m = readMacchina(fp);
				lm = consM(m, lm);
				break;
			case 'P':
				p = readParte(fp);
				lp = consP(p, lp);
				break;
			default:
				printf("Riga sconosciuta...");
		}
	}
	fclose(fp);

	lt = merge(lm, lp);

	while (!isEmptyT(lt))
	{
		printf("%d\t%s\n", (headT(lt).m)->id, (headT(lt).m)->nome);
		temp = headT(lt).p;
		while (!isEmptyP(temp))
		{
			printf("\t\t%d\t%s\t%d\n",
						headP(temp)->id,
						headP(temp)->nome,
						headP(temp)->costo);
			temp = tailP(temp);
		}
		printf("Numero totale parti: %d\n", countParte((headT(lt).m)->id, lt));
		printf("Costo totale: %d\n", costo((headT(lt).m)->id, lt));
		lt = tailT(lt);
	}

	// e la deallocazione della memoria occupata???
	destroyListT(lt);
	destroyM_w_content(lm);
	destroyP_w_content(lp);

	system("PAUSE");

	return (0);
}


